/*
 * Copyright 2004 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * $Header:$
 */
package org.apache.beehive.netui.pageflow;

import org.apache.beehive.netui.util.logging.Logger;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;


/**
 * ActionServlet that dynamically registers modules based on naming/location conventions for Struts
 * configuration files that are generated by the Page Flow compiler.  These files are located in
 * /WEB-INF/.pageflow-struts-generated, and are named jpf-struts-config-<i>module-name</i>.xml.
 * The user may specify additional ModuleConfigLocator classes in web.xml, using the
 * "moduleConfigLocators" init-parameter; this allows the user to define other patterns for
 * auto-registered Struts modules.
 * 
 * @deprecated Use {@link PageFlowActionServlet} instead.
 */
public class DynamicSubappActionServlet extends PageFlowActionServlet
{
    private static final Logger _log = Logger.getInstance( DynamicSubappActionServlet.class );
    
    public void init() throws ServletException
    {
        super.init();
        
        if ( _log.isWarnEnabled() )
        {
            _log.warn( DynamicSubappActionServlet.class.getName() + " is registered as the action Servlet. "
                       + "This class is deprecated; use " + PageFlowActionServlet.class.getName() + " instead." );
        }
    }
}
