/*
 * Copyright 2004 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * $Header:$
 */
package org.apache.beehive.netui.script.el.tokens;

public class ContextToken
    extends ExpressionToken {

    private String _context = null;

    public ContextToken(String context) {
        _context = context;
    }

    public void update(Object value, Object newValue) {
    }

    public String getName() {
        return _context;
    }

    public Object evaluate(Object value) {
        return null;
    }

    public String getTokenString() {
        return _context;
    }

    public String toString() {
        return _context;
    }
}
