package org.apache.beehive.netui.tags.rendering;

import org.apache.beehive.netui.util.Bundle;
import org.apache.beehive.netui.util.logging.Logger;
import org.apache.struts.util.RequestUtils;

import javax.servlet.jsp.JspContext;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.PageContext;
import java.io.IOException;

public class WriteRenderAppender extends AbstractRenderAppender
{
    private static final Logger logger = Logger.getInstance(WriteRenderAppender.class);

    private JspContext _jspC;

    public WriteRenderAppender()
    {
    }

    public WriteRenderAppender(JspContext jspC)
    {
        _jspC = jspC;
    }

    public void setPageContext(JspContext jspC)
    {
        _jspC = jspC;
    }

    public void append(String s)
    {
        JspWriter writer = _jspC.getOut();
        try {
            writer.print(s);
        }
        catch (IOException e) {
            if (_jspC instanceof PageContext)
                RequestUtils.saveException((PageContext) _jspC, e);
            logger.error(Bundle.getString("Tags_WriteException"), e);
        }
    }

    /**
     * This is a method not found on ResponseUtils and one that should be there.
     * @param c
     */
    public void append(char c)
    {
        JspWriter writer = _jspC.getOut();
        try {
            writer.print(c);
        }
        catch (IOException e) {
            if (_jspC instanceof PageContext)
                RequestUtils.saveException((PageContext) _jspC, e);
            logger.error(Bundle.getString("Tags_WriteException"), e);
        }
    }

}
