/*
 * Copyright 2005 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * $Header:$
 */
package org.apache.beehive.netui.core.urltemplates;

import org.apache.beehive.netui.core.urltemplates.schema.UrlTemplateConfigDocument;
import org.apache.beehive.netui.core.urltemplates.schema.UrlTemplateConfigDocument.UrlTemplateConfig;
import org.apache.xmlbeans.XmlException;

import java.io.InputStream;
import java.io.IOException;

/**
 * Default implementation for parsing url-template-config.
 */
public class DefaultURLTemplateFileParser implements URLTemplateFileParser
{
    public UrlTemplateConfig parse( InputStream istr ) throws XmlException, IOException
    {
        return UrlTemplateConfigDocument.Factory.parse( istr ).getUrlTemplateConfig();
    }
}
