/*
 * HandlerHandler.java
 * 
 * Copyright 2001-2004 The Apache Software Foundation.
 * 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */
package org.apache.beehive.wsm.axis.handlers;

import org.apache.axis.handlers.JAXRPCHandler;
import org.apache.beehive.wsm.model.BeehiveWsSOAPMessageHandlerInfo;
import org.apache.beehive.wsm.model.BeehiveWsTypeMetadata;
import org.apache.beehive.wsm.model.jsr181.SOAPMessageHandlerInfo;

/**
 * ****************************************************************************
 * Yes, this class name is a bit silly in order to highlight the confusion
 * caused by overloading the term "Handler" used both by jaxrpc and AXIS.
 * Might as well embrace the insanity rather than using an equally uninteresting
 * name like HandlerManager or something.
 *
 * @author Jonathan Colwell
 */
public class HandlerHandler extends JAXRPCHandler {

    private BeehiveWsTypeMetadata wsm;

    /**
     * Constructor with Jsr181TypeMetadata parameter
     *
     * @param wsm
     */
    public HandlerHandler(BeehiveWsTypeMetadata wsm) {
        this.wsm = wsm;
    }

    /**
     * Uses the soap handler configuration information in the metadata to
     * configure the HandlerChain.
     */
    public void init() {
        for (BeehiveWsSOAPMessageHandlerInfo info : wsm.getSoapHandlers()) {
            addNewHandler(info.getClassName(), info.getParameterMap());
        }
    }
}
