package org.apache.beehive.wsm.axis.security.model;

/*
 * DropInDeploymentHandler.java
 *
 * Copyright 2001-2004 The Apache Software Foundation.
 *
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

import java.util.Collection;
import java.util.Hashtable;
import java.util.Map;

import org.apache.beehive.wsm.axis.security.Group;
import org.apache.beehive.wsm.axis.security.User;
import org.apache.beehive.wsm.axis.security.UserList;
import org.apache.beehive.wsm.axis.security.Role;

public class MemoryUserListImpl implements UserList {

    private Map<String,User> users;
    private Map<String,Group> groups;
    private Map<String,Role> roles;

    public MemoryUserListImpl()
    {
        users  = new Hashtable<String,User>(); 
        groups = new Hashtable<String,Group>(); 
        roles  = new Hashtable<String,Role>(); 
    }

    public void addUser ( User user )
    {
        users.put(user.getName(), user);
    }

    public User getUser ( String name )
    {
        return users.get( name );
    }

    public Collection<User> getUsers ()
    {
        return users.values();
    }


    public void addGroup ( Group group )
    {
        groups.put(group.getName(), group );
    }

    public Group getGroup ( String name )
    {
        return groups.get( name );
    }

    public Collection<Group> getGroups ()
    {
        return groups.values();
    }


    public void addRole ( Role role )
    {
        roles.put(role.getName(), role);
    }

    public Role getRole ( String role )
    {
        return roles.get( role );
    }

    public Collection<Role> getRoles ()
    {
        return roles.values();
    }

}

