package org.apache.beehive.wsm.axis.tools;

import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;

import org.apache.beehive.wsm.axis.databinding.SystemTypeLookupService;
import org.apache.beehive.wsm.model.BeehiveWsTypeMetadata;
import org.apache.beehive.wsm.model.wsdl.XmlBeanWSDLProcessor;
import org.apache.beehive.wsm.wsdl.AbstractWsdl2AJava;
import org.apache.xmlbeans.XmlException;

/*
 * Wsld2AJava.java
 * 
 * Copyright 2001-2004 The Apache Software Foundation.
 * 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
public class Wsdl2AJava  extends AbstractWsdl2AJava{

	

	public Wsdl2AJava() throws Exception {
		super();
		// TODO Auto-generated constructor stub
	}


	protected BeehiveWsTypeMetadata getWSObjectModel(InputStream wsdl) throws Exception {
		XmlBeanWSDLProcessor processor = new XmlBeanWSDLProcessor(wsdl);
		SystemTypeLookupService lookupService = new SystemTypeLookupService();
		return processor.getObjectModel(lookupService);

	}
	
	
	public static int main(String args[]) throws Exception {
		if (args.length < 2) {
			System.out
					.println("Usage:  Wsdl2AJava <wsdlFileName> <base source dir>");
			return (-1);
		}
		Wsdl2AJava processor = new Wsdl2AJava();
		processor.init();
		processor.generateAnnotatedJavaFromWSDL(args[0], args[1]);
		return 0;

	}
}
