/*
 * Copyright 2004 The Apache Software Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * $Header:$Factory
 */
package org.apache.beehive.wsm.model;


import java.util.List;

import javax.xml.namespace.QName;

/**
 * @author Daryoush
 */
public interface BeehiveWsMethodMetadata {
    
    boolean isOneWay();
    void setOneWay(boolean oneway);
    
    
    String getWmAction();
    void setWmAction(String wmAction);
    
    String getWmOperationName();
    void setWmOperationName(String wmOperationName);
    
    String getWrName();
    void setWrName(String wrName);
    
    String getWrTargetNamespace();
    void setWrTargetNamespace(String wrTargetNamespace);
    
    List<BeehiveWsParameterMetadata> getParams();
    void addParam(BeehiveWsParameterMetadata parameter);
    void addParams(List<? extends BeehiveWsParameterMetadata> parameters);
    BeehiveWsParameterMetadata  findParam(String parmName);

    String getJavaMethodName();
    
    Class getJavaReturnType();
    String getJavaReturnTypeFullName();
    
    QName getXmlReturnType();
    void setXmlReturnType(QName xmlType);
	/**
	 * @param javaType
	 */
	void setReturnType(Class javaType);
}
