/*
 * Copyright 2005 The Apache Software Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * $Header:$Factory
 */
package org.apache.beehive.wsm.model;

import java.util.Collection;
import java.util.Map;

/**
 * @author dmehrtash
 */
public interface BeehiveWsSOAPMessageHandlerInfo {
  /**
   * @return Returns the className.
   */
  public abstract String getClassName();

  /**
   * @param className The className to set.
   */
  public abstract void setClassName(String className);

  /**
   * @return Returns the name.
   */
  public abstract String getName();

  /**
   * @param name The name to set.
   */
  public abstract void setName(String name);

  /**
   * @return Returns the headers.
   */
  public abstract Collection<String> getHeaders();

  public abstract void addHeader(String header);

  /**
   * @return Returns the params.
   */
  public abstract Map<String, String> getParameterMap();

  public abstract void addInitParam(String key, String value);

  public abstract void addInitParams(Map<String, String> params);

  /**
   * @return Returns the roles.
   */
  public abstract Collection<String> getRoles();

  public abstract void addRole(String role);

  public abstract void addRoles(Collection<String> roles);
}
