/*
 * Copyright 2004 The Apache Software Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * $Header:$Factory
 */
package org.apache.beehive.wsm.model;

import org.apache.beehive.wsm.model.java.JavaTypeInfo;

import java.net.URL;
import java.util.Collection;
import java.util.List;

/**
 * @author Daryoush
 */
public interface BeehiveWsTypeMetadata {

    void initHandlersFromChainConfig(URL chainConfigURL, String chainName)
        throws Exception;

    String getHcFileName();
    void setHcFileName(String hcFileName);
    
    public String getHcName();
    public void setHcName(String hcName);
        
    String getSiValue();
    void setSiValue(String siValue);
    
    BeehiveWsSOAPBindingInfo getSoapBinding();
    void setSoapBinding(BeehiveWsSOAPBindingInfo soapBinding);
    
    String getWsName();
    void setWsName(String wsName);
    
    String getWsServiceName();
    void setWsServiceName(String wsServiceName);
    
    String getWsTargetNamespace();
    void setWsTargetNamespace(String wsTargetNamespace);
    public String[] getTargetNamespaceParts();
    
    String getWsEndpointInterface();
    void setWsEndpointInterface(String wsEndpointInterface);
    
    String getWsWsdlLocation();
    void setWsWsdlLocation(String wsWsdlLocation);
    
    Collection<? extends BeehiveWsMethodMetadata> getMethods();

    public abstract BeehiveWsMethodMetadata getMethod(String methodName, Class... paramTypes);
    
    /**
     * @throws ValidationException if duplicate methods are encountered or if a
     * Document style service attempts to overload methods.
     */
    void addMethod(BeehiveWsMethodMetadata method) throws ValidationException;
    
    List<? extends BeehiveWsSOAPMessageHandlerInfo> getSoapHandlers();
    void addSOAPHandler(BeehiveWsSOAPMessageHandlerInfo soapHandler);
    
    String getClassName();
    void setClassName(String className);
    
    void merge(JavaTypeInfo jt) throws Exception;
}
