package org.apache.beehive.wsm.model.java;

/*
 * Copyright 2004 The Apache Software Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * $Header:$Factory
 */

import java.io.File;
import java.lang.annotation.Annotation;
import java.util.Collection;

public interface JavaTypeInfo {

    boolean isAbstract();
    boolean isFinal();
    boolean isPublic();
    boolean isInterface();
    boolean hasFinalize();
    boolean hasDefaultConstructor();
    
    String getName();
    File getLocation();

    void logError(String msg);
    
    <A extends Annotation> A getAnnotation(Class<A> annotationType);
    Collection<Annotation> getAnnotations();
    
    Collection<JavaMethodInfo> getMethods();
}
