package org.apache.beehive.wsm.model.jsr181;

import javax.jws.soap.InitParam;

/*
 * Copyright 2004 The Apache Software Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * $Header:$
 */

public class InitParamInfo implements java.io.Serializable {

    private static final long serialVersionUID = 1L;
    
    String name;

    String value;

    /**
     *  
     */
    public InitParamInfo(InitParam a) {
        super();
        initFromAnnotation(a);
    }

    /**
     * @param a
     */
    private void initFromAnnotation(InitParam a) {
        if (null != a) {
            setName(a.name());
            setValue(a.value());
        }
        // no defaults
    }

    /**
     * @return Returns the name.
     */
    public String getName() {
        return name;
    }

    /**
     * @param name The name to set.
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * @return Returns the value.
     */
    public String getValue() {
        return value;
    }

    /**
     * @param value The value to set.
     */
    public void setValue(String value) {
        this.value = value;
    }

}
