/*
 * WSDLProcessor.java
 * 
 * Copyright 2001-2004 The Apache Software Foundation.
 * 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.beehive.wsm.wsdl;

import org.apache.beehive.wsm.model.BeehiveWsTypeMetadata;

import java.io.InputStream;

/*******************************************************************************
 * Creates a WebServiceTYPEMetadata Object from a WSDL.
 *
 * @author Jonathan Colwell
 */
public interface WSDLProcessor {
    
    /**
     * Converts a WSDL document in the provided InputStream into the WSM 
     * Model.    
     * 
     * @param wsdlStream an InputStream containing a WSDL document.
     * @return a WSM Object model representing the service in the provided WSDL.
     */
    public BeehiveWsTypeMetadata createObjectModel(InputStream wsdlStream)
        throws Exception;
    
}
